require 'iconv'
require 'airport_record'
require 'metar_record'

class Avdata
  
  attr_accessor :directory, :apt_file
  
  def initialize args
    args.each do |k,v|
      instance_variable_set("@#{k}", v) unless v.nil?
    end
    
    if (self.directory != nil) && (File.directory?(self.directory))
      if File.exists?(File.expand_path('APT.txt', self.directory))
        self.apt_file = File.expand_path('APT.txt', self.directory)
      end
    end
    
  end
  
  def get_airports
    if self.apt_file
      return get_rows(self.apt_file,'APT')
      
    else
      return []
    end
    
  end
  
  def get_rows(file,prefix)
    
    results = []
    
    f = File.new(file, "r")
    while line = f.gets
      
      ic = Iconv.new('UTF-8//IGNORE', 'UTF-8')
      valid_line = ic.iconv(line + ' ')[0..-2]
      
      if valid_line.match(/^#{prefix}/)
        results << Airport_record.new(valid_line)
      end
    end
    
    return results
    
  end
  
end